#property indicator_separate_window

#property indicator_buffers 7

#property indicator_color1 Red
#property indicator_color2 DeepSkyBlue
#property indicator_color3 Yellow
#property indicator_color4 Lime
#property indicator_color5 White
#property indicator_color6 Magenta
#property indicator_color7 Maroon

#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 2
#property indicator_width6 2

#property indicator_minimum 0

extern int     NumberOfBars = 500;
extern string  Note = "0 means Display all bars";
extern int     MAPeriod = 100;
extern int     LookBack = 20;
extern string  Ticker = "AUTO";


double red[], blue[], yellow[], green[], white[], magenta[], v4[];
double Vol[];

datetime LastAvailable = 0;

int VolumeLowest(int count, int start)
{
   double min = EMPTY_VALUE;
   int idx = -1;
   for (int i = start + 1; i < start + count; i++)
   {
      if (Vol[i] != EMPTY_VALUE && Vol[i] < min)
      {
         min = Vol[i];
         idx = i;
      }
   }
   return (idx);
}

int init()
{
   IndicatorBuffers(8);

   SetIndexBuffer(0, red);
   SetIndexBuffer(1, blue);
   SetIndexBuffer(2, yellow);
   SetIndexBuffer(3, green);
   SetIndexBuffer(4, white);
   SetIndexBuffer(5, magenta);
   SetIndexBuffer(6, v4);
   SetIndexBuffer(7, Vol);

   SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexStyle(1, DRAW_HISTOGRAM);
   SetIndexStyle(2, DRAW_HISTOGRAM);
   SetIndexStyle(3, DRAW_HISTOGRAM);
   SetIndexStyle(4, DRAW_HISTOGRAM);
   SetIndexStyle(5, DRAW_HISTOGRAM);
   SetIndexStyle(6, DRAW_LINE, 0, 2);

   SetIndexLabel(0, "Climax High");
   SetIndexLabel(1, "Neutral");
   SetIndexLabel(2, "Low");
   SetIndexLabel(3, "HighChurn");
   SetIndexLabel(4, "Climax Low");
   SetIndexLabel(5, "ClimaxChurn");
   SetIndexLabel(6, "Average(" + MAPeriod + ")");

   IndicatorShortName("Better Volume ClusterX Edition");
   return(0);
}

int start()
{
   int counted_bars = IndicatorCounted();
   if (counted_bars > 0) counted_bars--;
   
   if (NumberOfBars == 0) NumberOfBars = Bars - counted_bars;
   int limit = MathMin(NumberOfBars, Bars - counted_bars);

   int shift = iBarShift(Symbol(), Period(), LastAvailable) + 1;
   if (shift > limit) limit = shift;

   for(int i = limit - 1; i >= 0; i--)
   {
      Vol[i] = iCustom(Symbol(), 0, "ClusterX_Volume", Ticker, 0, i);
      if (Vol[i] != EMPTY_VALUE)
      {
         LastAvailable = Time[i];
      }
   }

   for(i = 0; i < limit; i++)
   {
      red[i] = 0; 
      blue[i] = Vol[i]; 
      yellow[i] = 0; 
      green[i] = 0; 
      white[i] = 0; 
      magenta[i] = 0;
      
      int lowestIdx = VolumeLowest(20, i);
      if (lowestIdx == -1) continue;
      
      double volLowest = Vol[lowestIdx];
      if (volLowest == EMPTY_VALUE) continue;
      
      if (Vol[i] == volLowest)
      {
         yellow[i] = Vol[i];
         blue[i] = 0;
      }

      double Range = (High[i] - Low[i]);
      if (Range < 0.5*Point) continue;
      
      double Value2 = Vol[i]*Range;
      
      double Value3 = 0;
      if (Range != 0) Value3 = Vol[i]/Range;

      double tempv = 0;
      for (int n = i; n < i + MAPeriod; n++)
      {
         if (Vol[n] != EMPTY_VALUE)
         tempv += Vol[n]; 
      } 
      
      double tempv2 = 0, tempv3 = 0, HiValue2 = 0, HiValue3 = 0, LoValue3 = EMPTY_VALUE;
      for (n = i; n < i + LookBack; n++)
      {
         if (Vol[n] != EMPTY_VALUE)
         {
            tempv2 = Vol[n]*((High[n] - Low[n])); 

            if ( tempv2 >= HiValue2 )
               HiValue2 = tempv2;

            if ( tempv2 != 0 )
            {
               tempv3 = Vol[n] / ((High[n] - Low[n]));
               if ( tempv3 > HiValue3 ) 
                  HiValue3 = tempv3; 
               if ( tempv3 < LoValue3 )
                  LoValue3 = tempv3;
            } 
         }
      }

      v4[i] = NormalizeDouble(tempv/MAPeriod,0);
              
      if ( Value2 == HiValue2 && Close[i] > (High[i] + Low[i]) / 2 )
      {
         red[i] = NormalizeDouble(Vol[i], 0);
         blue[i] = 0;
         yellow[i] = 0;
      }   

      if ( Value3 == HiValue3 )
      {
         green[i] = NormalizeDouble(Vol[i], 0);                
         blue[i] = 0;
         yellow[i]= 0;
         red[i] = 0;
      }
      
      if ( Value2 == HiValue2 && Value3 == HiValue3 )
      {
         magenta[i] = NormalizeDouble(Vol[i], 0);
         blue[i] = 0;
         red[i] = 0;
         green[i] = 0;
         yellow[i] = 0;
      }
      
      if ( Value2 == HiValue2 && Close[i] <= (High[i] + Low[i]) / 2 )
      {
         white[i] = NormalizeDouble(Vol[i], 0);
         magenta[i] = 0;
         blue[i] = 0;
         red[i] = 0;
         green[i] = 0;
         yellow[i] = 0;
      } 
   }
   
   return(0);
}